<template>
  <Container class="h-full">
    <section class="flex items-center justify-between gap-2">
      <SectionHeader icon="mdi-briefcase-account-outline">
        Гости
      </SectionHeader>

      <v-scroll-y-transition>
        <v-btn
          v-if="booking.status === BookingStatus.BOOKED"
          variant="tonal"
          class="text-amber-600 flex-initial"
          size="small"
          icon="mdi-pencil"
          @click="isEditShown = true"
        />
      </v-scroll-y-transition>
    </section>

    <section class="mt-4 grid grid-cols-12 gap-4">
      <Container class="flex items-center gap-2 col-span-12 md:col-span-6 !bg-gray-100 !p-4 !shadow-none">
        <section class="flex items-center justify-center shrink-0 w-10 h-10 rounded-lg text-white bg-gradient-to-l from-teal-400 to-cyan-500">
          <v-icon
            icon="mdi-account"
            size="large"
          />
        </section>

        <section class="flex items-center gap-1 text-lg">
          <span class="text-gray-600">
            Взрослые:
          </span>

          <span class="font-bold text-xl">
            {{ booking.adults }}
          </span>
        </section>
      </Container>

      <Container class="flex items-center gap-2 col-span-12 md:col-span-6 !bg-gray-100 !p-4 !shadow-none">
        <section class="flex items-center justify-center shrink-0 w-10 h-10 rounded-lg text-white bg-gradient-to-l from-teal-400 to-cyan-500">
          <v-icon
            icon="mdi-teddy-bear"
            size="large"
          />
        </section>

        <section class="flex items-center gap-1 text-lg">
          <span class="text-gray-600">
            Дети:
          </span>

          <span class="font-bold text-xl">
            {{ booking.children }}
          </span>
        </section>
      </Container>
    </section>

    <v-card
      v-tooltip="{ text: 'Нажмите, чтобы перейти к гостю', openOnClick: true }"
      class="mt-4 bg-gray-100 rounded-[12px]"
      variant="text"
      link
      @click="$router.push({
        path: `/guests/${booking.guest.id}`,
        query: { fromBooking: booking.id },
      })"
    >
      <template #prepend>
        <TextAvatar :value="booking.guest.name" />
      </template>

      <template #title>
        <span class="select-none">
          {{ booking.guest.name }}
        </span>
      </template>

      <template #subtitle>
        <span class="select-none">
          Контактное лицо
        </span>
      </template>

      <template #append>
        <v-icon icon="mdi-open-in-new" />
      </template>
    </v-card>

    <section v-if="booking.guest.phones.length">
      <section class="mt-2 text-lg font-light text-gray-500">
        Номера телефонов
      </section>

      <v-list lines="one">
        <v-list-item
          v-for="(phone, index) in booking.guest.phones"
          :key="phone.id"
          :title="getFormattedPhoneNumber(phone.value)"
          :class="{ 'bg-gray-100': index % 2 === 0 }"
          class="py-2"
          prepend-icon="mdi-text-short"
        >
          <template #prepend>
            <v-btn
              v-tooltip:top-start="{ text: 'Нажмите, чтобы позвонить', openOnClick: true }"
              icon="mdi-phone"
              :href="getTelHref(phone.value)"
              variant="tonal"
              size="small"
              class="text-teal-600 mr-4"
            />
          </template>
        </v-list-item>
      </v-list>
    </section>

    <section v-if="booking.guest.notes.length">
      <section class="mt-2 text-lg font-light text-gray-500">
        Заметки
      </section>

      <v-list lines="one">
        <v-list-item
          v-for="(note, index) in booking.guest.notes"
          :key="note.id"
          class="[&_.v-list-item-title]:whitespace-normal"
          :class="{ 'bg-gray-100': index % 2 === 0 }"
          :title="note.text"
          prepend-icon="mdi-text-short"
        />
      </v-list>
    </section>
  </Container>

  <v-dialog
    v-model="isEditShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение гостей"
        subtitle="Прибыль от бронирования будет пересчитана"
      />

      <section class="pt-4">
        <FormRow label="Взрослые">
          <NumberInput
            v-model="updatedAdults"
            mode="integer"
            :min="1"
            :step="1"
          />
        </FormRow>

        <FormRow label="Дети">
          <NumberInput
            v-model="updatedChildren"
            mode="integer"
            :min="0"
            :step="1"
          />
        </FormRow>

        <v-scroll-y-transition>
          <v-alert
            icon="mdi-information-outline"
            class="mt-4 text-teal-600 bg-teal-50 border-2 border-teal-100 min-w-full w-min"
            closable
          >
            Расчет по тарифу производится только для взрослых гостей
          </v-alert>
        </v-scroll-y-transition>

        <v-scroll-y-transition>
          <v-alert
            v-if="isCapacityExceedShown"
            icon="mdi-alert-outline"
            class="mt-4 text-yellow-600 bg-yellow-50 border-2 border-yellow-100 min-w-full w-min"
          >
            Указанное число гостей (<b>{{ updatedAdults + updatedChildren }}</b>) превышает максимальную
            вместимость выбранного объекта (<b>{{ booking.property.capacity }}</b>)
          </v-alert>
        </v-scroll-y-transition>

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            @click="onGuestsCountUpdate"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="onGuestsCountUpdateCancel"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import { BookingStatus } from '@/declarations';
import { getFormattedPhoneNumber } from '@/utils';

import Container from '@/components/layout/Container.vue';
import TextAvatar from '@/components/content/TextAvatar.vue';

import SectionHeader from '@/components/layout/SectionHeader.vue';
import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import NumberInput from '@/components/content/NumberInput.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
const emit = defineEmits(['update:guests-count']);

const isEditShown = ref(false);
const updatedAdults = ref(props.booking.adults);
const updatedChildren = ref(props.booking.children);

const isCapacityExceedShown = computed(() => {
  if (!props.booking.property) return false;

  const maxCapacity = props.booking.property.capacity;
  const currentGuestsCount = updatedAdults.value + updatedChildren.value;

  return currentGuestsCount > maxCapacity;
});

const getTelHref = (phone: string) => `tel:${phone}`;

const onGuestsCountUpdate = () => {
  const adults = updatedAdults.value;
  const children = updatedChildren.value;

  isEditShown.value = false;
  emit('update:guests-count', { adults, children });
};

const onGuestsCountUpdateCancel = () => {
  isEditShown.value = false;

  updatedAdults.value = props.booking.adults;
  updatedChildren.value = props.booking.children;
};

watch(isEditShown, () => {
  updatedAdults.value = props.booking.adults;
  updatedChildren.value = props.booking.children;
});
</script>